// (c) Ludewig, Lichter, 2023
// Software Engineering – Grundlagen, Menschen, Prozesse, Techniken. 4. Auflage, dpunkt.verlag Heidelberg

#include <stdio.h>
#include "datastore.h"

#define MAX 50                       // max. no of key-value pairs

static KeyValPair *datastore[MAX];   // store pairs in an array
static int noOfPairs = 0;            // no of stored pairs


void addPair(KeyValPair *pair) {
  int i;
  if (noOfPairs<MAX) {                          // datastore not full
    datastore[noOfPairs] = pair;
    noOfPairs++;
    i = 0;                                      // search with sentinel
    while (datastore[i]->key != pair->key) i++;
    if (i<noOfPairs-1) noOfPairs--;             // pair removed
  }                                             // if key already exists
}

void removePair(int key){
  int i;
  i = 0;
  while ((datastore[i]->key != key) && (i<MAX)) i++;
  if (i<noOfPairs-1) {
      datastore[i] = datastore[noOfPairs-1];
      noOfPairs--;
  } else noOfPairs--;
};

Data* getValue(int key){
  int i;
  i = 0;
  while ((datastore[i]->key != key) && (i<MAX)) i++;
  if (i<noOfPairs-1) return &datastore[i]->content;
};

void print() {
  int i;
  printf("%s \n", "===================");
  printf("%s %i \n", "Pairs = ", noOfPairs);
  for (i=0; i<noOfPairs; i++){
      printf("%i %s \n", datastore[i]->key, datastore[i]->content);
  }
  printf("%s \n", "===================");
}

